# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.User do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :realm,
    :email,
    :username,
    :firstName,
    :lastName,
    :phone,
    :phoneVerified,
    :smsVerificationCode,
    :profileImage,
    :location,
    :newUser,
    :emailVerified,
    :verificationToken,
    :parentId,
    :updatedAt,
    :createdAt,
    :Member,
    :Publisher,
    :Shopper,
    :Usages,
    :Favorites,
    :ShareReceivers,
    :ShareSenders,
    :Transactions,
    :Trials
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :realm => String.t | nil,
    :email => String.t | nil,
    :username => String.t | nil,
    :firstName => String.t | nil,
    :lastName => String.t | nil,
    :phone => String.t | nil,
    :phoneVerified => boolean() | nil,
    :smsVerificationCode => integer() | nil,
    :profileImage => String.t | nil,
    :location => FoyerAPI.Model.Location.t | nil,
    :newUser => boolean() | nil,
    :emailVerified => boolean() | nil,
    :verificationToken => String.t | nil,
    :parentId => integer() | nil,
    :updatedAt => Date.t | nil,
    :createdAt => Date.t | nil,
    :Member => FoyerAPI.Model.Member.t | nil,
    :Publisher => FoyerAPI.Model.Publisher.t | nil,
    :Shopper => FoyerAPI.Model.Shopper.t | nil,
    :Usages => [FoyerAPI.Model.ApiUsage.t] | nil,
    :Favorites => [FoyerAPI.Model.Favorite.t] | nil,
    :ShareReceivers => [FoyerAPI.Model.Share.t] | nil,
    :ShareSenders => [FoyerAPI.Model.Share.t] | nil,
    :Transactions => [FoyerAPI.Model.Transaction.t] | nil,
    :Trials => [FoyerAPI.Model.Trial.t] | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.User do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:location, :struct, FoyerAPI.Model.Location, options)
    |> deserialize(:updatedAt, :date, nil, options)
    |> deserialize(:createdAt, :date, nil, options)
    |> deserialize(:Member, :struct, FoyerAPI.Model.Member, options)
    |> deserialize(:Publisher, :struct, FoyerAPI.Model.Publisher, options)
    |> deserialize(:Shopper, :struct, FoyerAPI.Model.Shopper, options)
    |> deserialize(:Usages, :list, FoyerAPI.Model.ApiUsage, options)
    |> deserialize(:Favorites, :list, FoyerAPI.Model.Favorite, options)
    |> deserialize(:ShareReceivers, :list, FoyerAPI.Model.Share, options)
    |> deserialize(:ShareSenders, :list, FoyerAPI.Model.Share, options)
    |> deserialize(:Transactions, :list, FoyerAPI.Model.Transaction, options)
    |> deserialize(:Trials, :list, FoyerAPI.Model.Trial, options)
  end
end

